<?php
/*
 * 簡易投票処理スクリプト
 * 
 * @package 金魚屋「車輪の再開発」シリーズ
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @license http://www.kingyoya.org/
 * @version 1.2.0
 * @date 2008-03-11
 *
 */

/* check for direct access */
if (!defined('_KINGYOYA_SIMPLEVOTE')) {
	header('HTTP/1.0 403 Forbidden');
	exit;
}
/* 初期設定読み込み */
require_once './initialize.php';

/*
 * 日本語環境の設定
 * 不要な場合は削除
 */
mb_language('Japanese');
mb_internal_encoding('utf8');
mb_http_output(OUTPUT_CHARSET);
ob_start('mb_output_handler');

require_once CLASS_ROOT.'/SimpleVote.php';

function redirect() {
	header('HTTP/1.0 303 See Other');
	header('Location: '. $_SERVER['REQUEST_URI']);
	exit;
}

if (!defined('DATA_FILE')) {
	die("Data file is not set");
}
if (!is_file(DATA_FILE)) {
	die("Data file is not file: ".DATA_FILE);
}
if (!is_readable(DATA_FILE)) {
	die("Data file is not readable file: ".DATA_FILE);
}
if (!is_writable(DATA_FILE)) {
	die("Data file is not writable file: ".DATA_FILE);
}

$votor = new Kingyoya_SimpleVote(DATA_FILE);

/**
 * 簡易投票スクリプト
 */
if (strtolower($_SERVER['REQUEST_METHOD']) === 'post') {
	/*
	 * 投票時処理
	 */
	if (isset($_COOKIE[COOKIE_NAME])) {
		// 重複投票
		trigger_error('Already voted', E_USER_NOTICE);
	} else if (!isset($_POST['vote'])) {
		// 投票値なし
		trigger_error('Failed get vote', E_USER_WARNING);
	} else {
		$vote = (string) $_POST['vote'];
		if (!$vote) {
			// 投票値なし
			trigger_error('Failed get int vote', E_USER_WARNING);
		} else {
			$lock = fopen(LOCK_FILE, 'w');
			if (!$lock) {
				trigger_error('Failed open lock file: '.LOCK_FILE, E_USER_WARNING);
			} else {
				$result = flock($lock, LOCK_EX);
				if (!$lock) {
					trigger_error('Failed lock: '.LOCK_FILE, E_USER_WARNING);
					redirect();
				}
			
				$result = $votor->vote((string) $vote);
				if (!$result) {
					trigger_error('Failed vote', E_USER_WARNING);
				}
			
				fclose($lock);
			
				if (defined('COOKIE_EXPIRE') && COOKIE_EXPIRE) {
					setcookie(COOKIE_NAME, 1, time()+COOKIE_EXPIRE);
				} else {
					setcookie(COOKIE_NAME, 1);
				}
			}
		}
	}

}

/*
 * 通常時処理
 */
$result = $votor->load();
if (!$result) {
	trigger_error('Failed load data', E_USER_WARNING);
}
